/**
 * Diese Klasse kapselt ein abstraktes TSP-Problem.
 * Alle Werte der GUI finden sich hier fr ein Szenario
 */
package de.hwrBerlin.ameisenproblem.databeans;

import java.util.List;

/**
 * 
 * @author Nico Smeenk
 * 
 *         Speichert ein TSP Szenario
 */
public class TSPScenario {
    // parameter
    double alpha;
    double beta;
    double rho;
    double tau0;
    double q;
    // zielbedingung
    int skIteration = 0;
    double skThreshold = 0;
    String skBestTourPath = "";
    // sonstiges
    int numberAnt;
    int numberCities;
    
    List<Coordinate> tspCoordinates;
    
    

    /**
     * @return the alpha
     */
    public double getAlpha() {
        return alpha;
    }
    


    /**
     * @param pAlpha
     *            the alpha to set
     */
    public void setAlpha(double pAlpha) {
        alpha = pAlpha;
    }
    


    /**
     * @return the beta
     */
    public double getBeta() {
        return beta;
    }
    


    /**
     * @param pBeta
     *            the beta to set
     */
    public void setBeta(double pBeta) {
        beta = pBeta;
    }
    


    /**
     * @return the rho
     */
    public double getRho() {
        return rho;
    }
    


    /**
     * @param pRho
     *            the rho to set
     */
    public void setRho(double pRho) {
        rho = pRho;
    }
    


    /**
     * @return the tau0
     */
    public double getTau0() {
        return tau0;
    }
    


    /**
     * @param pTau0
     *            the tau0 to set
     */
    public void setTau0(double pTau0) {
        tau0 = pTau0;
    }
    


    /**
     * @return the q
     */
    public double getQ() {
        return q;
    }
    


    /**
     * @param pQ
     *            the q to set
     */
    public void setQ(double pQ) {
        q = pQ;
    }
    


    /**
     * @return the skIteration
     */
    public int getSkIteration() {
        return skIteration;
    }
    


    /**
     * @param pSkIteration
     *            the skIteration to set
     */
    public void setSkIteration(int pSkIteration) {
        skIteration = pSkIteration;
    }
    


    /**
     * @return the skThreshold
     */
    public double getSkThreshold() {
        return skThreshold;
    }
    


    /**
     * @param pSkThreshold
     *            the skThreshold to set
     */
    public void setSkThreshold(double pSkThreshold) {
        skThreshold = pSkThreshold;
    }
    


    /**
     * @return the skBestTourPath
     */
    public String getSkBestTourPath() {
        return skBestTourPath;
    }
    


    /**
     * @param pSkBestTourPath
     *            the skBestTourPath to set
     */
    public void setSkBestTourPath(String pSkBestTourPath) {
        skBestTourPath = pSkBestTourPath;
    }
    


    /**
     * @return the numberAnt
     */
    public int getNumberAnt() {
        return numberAnt;
    }
    


    /**
     * @param pNumberAnt
     *            the numberAnt to set
     */
    public void setNumberAnt(int pNumberAnt) {
        numberAnt = pNumberAnt;
    }
    


    /**
     * @return the numberCities
     */
    public int getNumberCities() {
        return numberCities;
    }
    


    /**
     * @param pNumberCities
     *            the numberCities to set
     */
    public void setNumberCities(int pNumberCities) {
        numberCities = pNumberCities;
    }
    


    /**
     * @return the tspCoordinates
     */
    public List<Coordinate> getTspCoordinates() {
        return tspCoordinates;
    }
    


    /**
     * @param pTspCoordinates
     *            the tspCoordinates to set
     */
    public void setTspCoordinates(List<Coordinate> pTspCoordinates) {
        tspCoordinates = pTspCoordinates;
    }
    
}
