/**
 * 
 */
package de.hwrBerlin.ameisenproblem.test;

import java.util.Map;

import de.hwrBerlin.ameisenproblem.controller.MainController;
import de.hwrBerlin.ameisenproblem.databeans.Ant;
import de.hwrBerlin.ameisenproblem.databeans.Coordinate;
import de.hwrBerlin.ameisenproblem.databeans.Transition;

/**
 * @author Nico Smeenk
 * 
 */
public class Test {
    
    private static MainController _mainController;
    private static Coordinate coordinate;
    private static Coordinate coordinate1;
    private static Coordinate coordinate2;
    
    

    /**
     * @param args
     */
    public static void main(String[] args) {
        _mainController = new MainController();
        
        // Koordinaten erstellen
        coordinate = new Coordinate();
        coordinate.setName("-");
        coordinate.setxValue(20.0);
        coordinate.setyValue(20.0);
        try {
            _mainController.addCoordinate(coordinate);
        }
        catch (NullPointerException e) {
        }
        
        coordinate1 = new Coordinate();
        coordinate1.setName(" | ");
        coordinate1.setxValue(0.0);
        coordinate1.setyValue(0.0);
        try {
            _mainController.addCoordinate(coordinate1);
        }
        catch (NullPointerException e) {
        }
        
        coordinate2 = new Coordinate();
        coordinate2.setName("| |");
        coordinate2.setxValue(5.0);
        coordinate2.setyValue(5.0);
        try {
            _mainController.addCoordinate(coordinate2);
        }
        catch (NullPointerException e) {
        }
        
        // Transitions erstellen
        _mainController.initTransitions(2.5);
        
        // Testen
        System.out.println("################################## testGetCanGoToCoordiante go ");
        testGetCanGoToCoordiante();
        System.out.println("################################## testGetCanGoToCoordiante end ");
        System.out.println("################################## testProbabilityOfNext go ");
        testProbabilityOfNext();
        System.out.println("################################## testProbabilityOfNext end ");
        System.out.println("################################## antRunTest go ");
        antRunTest();
        System.out.println("################################## antRunTest end ");
        System.out.println("################################## transitionEquals go ");
        transitionEqualsTest();
        System.out.println("################################## transitionEquals end ");
        
    }
    


    /**
     * 
     */
    private static void transitionEqualsTest() {
        Coordinate coordinate1 = new Coordinate();
        Coordinate coordinate2 = new Coordinate();
        
        Transition transition1 = new Transition(coordinate1, coordinate2);
        Transition transition2 = new Transition(coordinate2, coordinate1);
        
        if (transition1.equals(transition1)){
            System.out.println("1 == 1");
        }
        if (transition2.equals(transition2)){
            System.out.println("2 == 2");
        }
        if (transition1.equals(transition2)){
            System.out.println("1 == 2");
        }
        if (transition2.equals(transition1)){
            System.out.println("2 == 1");
        }
    }



    /**
     * 
     */
    private static void antRunTest() {
        Ant ant = new Ant();
        for (int i = 0; i < 10; i++) {
            _mainController.runAnt(1, 1, ant);
            System.out.println(ant.getWay());
        }
    }
    


    /**
     * 
     */
    private static void testProbabilityOfNext() {
        Ant ant = new Ant();
        ant.addCoordinateToWay(coordinate);
        
        Map<Coordinate, Double> transitionProbability = _mainController.getTransitionProbability(1, 1, ant);
        for (Coordinate coordinate : transitionProbability.keySet()) {
            System.out.println(coordinate);
            System.out.println("  wahrscheinlichkeit: " + transitionProbability.get(coordinate));
        }
    }
    


    /**
     * 
     */
    private static void testGetCanGoToCoordiante() {
        Ant ant = new Ant();
        ant.addCoordinateToWay(coordinate);
        
        for (Coordinate cangoto : _mainController.getCanGoToCoordinate(ant)) {
            System.out.println(cangoto);
            System.out.println("  length: " + _mainController.getTransitionData(new Transition(coordinate, cangoto)).getLength());
            System.out.println("  pheromone: " + _mainController.getTransitionData(new Transition(coordinate, cangoto)).getPheromone());
            System.out.println("  wahrscheinlichkeit: " + _mainController.getVektorProbability(1, 1, new Transition(coordinate, cangoto)));
        }
    }
    
    
    
}
