/**
 * 
 */
package de.hwrBerlin.ameisenproblem.view;

import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.RGB;

/**
 * @author Nico Smeenk
 * 
 */
public class Constants {
    
    public static final String[] TSP_FILE_EXTENSION = { "*.tsp" };
    public static final String[] TOUR_FILE_EXTENSION = { "*.tour" };
    public static final String VERSION = "1.0";
    public static final String[] DEVELOPER_LIST = { "Nico Smeenk", "Jonathan Wiens", "Benjamin Pfeiffer", "Sebastian Groe", "Christian Gebauer" };
    
    public static final String LOGO = "Images/logo.png";
    public static final String BIG_LOGO = "Images/bigLogo.png";
    public static final String SMALL_LOGO = "Images/smallLogo.png";
    public static final Image[] ICON_ARRAY = { new Image(null, "Images/icons/icon_16x16.png"), new Image(null, "Images/icons/icon_24x24.png"), new Image(null, "Images/icons/icon_32x32.png"),
            new Image(null, "Images/icons/icon_48x48.png"), new Image(null, "Images/icons/icon_64x64.png"), new Image(null, "Images/icons/icon_128x128.png"),
            new Image(null, "Images/icons/icon_256x256.png"), new Image(null, "Images/icons/icon_512x512.png") };
    public static final String MAIN_TITLE = "ANTS on Crack";
    public static final String HANDBOOK_TITLE = "Handbuch";
    public static final String ABOUT_TITLE = "ber";
    protected static final String NEW_COORDINATE_TITLE = "Koordinate erstellen";
    public static final String HANDBOOK_DESCRIPTION = "Dieses Programm simuliert den Ameisenalgorithmus angwendet auf \ndas Traveling Salesman Problem (TSP). Fr das Berechnen eines Weges \n"
            + "muss zunchst eine Datei geladen werden, oder es werden per Mausklick \nneue Koordinaten durch die graphische Oberflche eingefgt. \n"
            + "Auerdem knnen neu angelegte Routenpunkte gespeichert werden. \nDie gefundene bestmgliche Route kann ebenfalls abgespeichert werden. \n"
            + "Weitere Informationen zu den einzelnen Einstellungsmglichkeiten finden Sie unter:";
    public static final String HANDBOOK_LINK = "http://lisa-debian-server.dyndns.org/mediawiki/index.php/TSP-Ameisenalgorithmus:_Handbuch";
    
    public static final String PHEROMON_PARAMETER_VARIABLE = "\u03B1";
    public static final String PHEROMON_PARAMETER_TOOLTIP = "Die Pheromonsensibilitt bestimmt wie wichtig\ndie Pheromonspuren fr die Ameise sind.\nJe hoeher der Wert, desto"
            + " mehr Wichtigkeit\nlegt die Ameise auf die Pheromonenspur.";
    public static final String HEURISTISCHER_PARAMETER_VARIABLE = "\u03B2";
    public static final String HEURISTISCHER_PARAMETER_TOOLTIP = "Die Heuristik bestimmt wie wichtig lokale\nInformationen fr eine Ameise ist."
            + "\nLokale Informationen bedeutet wie lang ein Weg ist.";
    public static final String VERDUNSTUNGSFAKTOR_VARIABLE = "\u03C1";
    public static final String VERDUNSTUNGSFAKTOR_TOOLTIP = "Der Verdunstungsfaktor bestimmt, wie schnell\ndie Pheromonspuren verdunsten sollen.";
    public static final String INITIALER_PHEROMON_WERT_VARIABLE = "\u03C40";
    public static final String INITIALER_PHEROMON_TOOLTIP = "Der initiale Pheromonwert bestimmt,\nwieviele Pheromone auf jeden Weg\ngesprht werden sollen.";
    public static final String PHEROMON_UPDATE_VARIABLE = "Q";
    public static final String PHEROMON_UPDATE_TOOLTIP = "Das Pheromonupdate bestimmt die Menge\nder Pheromone die Ameise fr eine gesamte Route hat.";
    
    public static final String PHEROMON_PARAMETER_VARIABLE_DESCRIPTION = PHEROMON_PARAMETER_VARIABLE + " = Pheromon Parameter (0<" + PHEROMON_PARAMETER_VARIABLE + "\u22641)";
    public static final String HEURISTISCHER_PARAMETER_VARIABLE_DESCRIPTION = HEURISTISCHER_PARAMETER_VARIABLE + " = heuristischer Parameter fr die lokale Information (0<"
            + HEURISTISCHER_PARAMETER_VARIABLE + "\u22641)";
    public static final String VERDUNSTUNGSFAKTOR_VARIABLE_DESCRIPTION = VERDUNSTUNGSFAKTOR_VARIABLE + " = Verdunstungsfaktor (0<" + VERDUNSTUNGSFAKTOR_VARIABLE + "\u22641)";
    public static final String INITIALER_PHEROMON_WERT_VARIABLE_DESCRIPTION = INITIALER_PHEROMON_WERT_VARIABLE + " = initiale Pheromon-Werte (" + INITIALER_PHEROMON_WERT_VARIABLE + ">0)";
    public static final String PHEROMON_UPDATE_VARIABLE_DESCRIPTION = PHEROMON_UPDATE_VARIABLE + " = heuristischer Parameter fr Pheromon-Update (" + PHEROMON_UPDATE_VARIABLE + ">0)";
    
    public static final String BROWSE_IMAGE = "Images/browse.png";
    
    public static final String NUMBER_CITY_TXT = "Anzahl der Stdte: ";
    public static final String BEST_TOUR_TXT = "Lnge der zur Zeit besten Tour:";
    public static final String AVERAGE_TOUR_TXT = "Lnge der durchschnittlichen Tour:";
    public static final String TIME_LEFT_TXT = "Vergangene Zeit (ms): ";
    public static final String ITERATION_TXT = "Iterationen: ";
    public static final String GLOBAL_TXT = "global: ";
    
    protected static final String ERROR_TITLE_ON_OPEN_WHILE_RUNNING = "Laden zur Zeit nicht mglich";
    protected static final String ERROR_TEXT_ON_OPEN_WHILE_RUNNING = "Whrend eines laufes kann kein neues TSP-file geladen werden. Bitte beenden sie den Durchlauf, um eine neue Quelldatei auszuwhlen.";
    protected static final String ERROR_TITLE_SAVE_NO_POINTS = "Keine Punkte im TSP";
    protected static final String ERROR_TEXT_SAVE_NO_POINTS = "Das TSP kann nicht gespeichert werden, da keine Punkte vorhanden sind.";
    protected static final String ERROR_TITLE_SAVE_RESULT_NO_RESULT = "Kein Ergebnis vorhanden";
    protected static final String ERROR_TEXT_SAVE_RESULT_NO_RESULT = "Es wurde kein Ergebins berechnet, welches abgespeichert werden knnte!";
    protected static final String ERROR_TITLE_ON_RANDOM_WHILE_RUNNING = "Zufallswerte nicht mglich";
    protected static final String ERROR_TEXT_ON_RANDOM_WHILE_RUNNING = "Whrend eines laufes knnen keine neuen Daten erzeugt werden.";
    
    // Konstanten fr den File Im- und Export
    
    // Festgelegte Dateifelder (Tags)
    public final static String TSP_HEADER_END = "NODE_COORD_SECTION";
    public final static String TSP_COORDINATE_COUNT_HEADER = "DIMENSION:";
    public final static String TOUR_HEADER_END = "TOUR_SECTION";
    public final static String ALTERNATIVE_HEADER_END = "1 ";
    public final static String FILE_END = "EOF";
    
    public static final String ZOOM_OUT_IMAGE = "Images/zoom_out.png";
    public static final String ZOOM_IN_IMAGE = "Images/zoom_in.png";
    
    // Farben fr die textfelder
    public static RGB RED_COLOR = new RGB(255, 100, 100);
    public static RGB WHITE_COLOR = new RGB(255, 255, 255);
}
